<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 14/02/20
 * Time: 11.58
 */
namespace FiloBlu\Rma\Plugin\Model\Rma;


use FiloBlu\Rma\Helper\ChangeSizeAttributeHelper;

class RmaDataMapper
{
    /**
     * @var ChangeSizeAttributeHelper
     */
    protected $changeSizeAttributeHelper;

    /**
     * RmaDataMapper constructor.
     * @param ChangeSizeAttributeHelper $changeSizeAttributeHelper
     */
    public function __construct(ChangeSizeAttributeHelper $changeSizeAttributeHelper)
    {
        $this->changeSizeAttributeHelper = $changeSizeAttributeHelper;
    }


    /**
     * @param \Magento\Rma\Model\Rma\RmaDataMapper $subject
     * @param array $saveRequest
     * @return array
     */
    public function beforeFilterRmaSaveRequest(\Magento\Rma\Model\Rma\RmaDataMapper $subject, array $saveRequest){

        $changeSizeAttributeId = $this->changeSizeAttributeHelper->getChangeSizeAttributeOptionId();
        foreach ($saveRequest['items'] as $key => $itemData) {
            if(isset($itemData['resolution']) && $itemData['resolution'] == $changeSizeAttributeId){
                if(isset($itemData['change_size'])){
                    $saveRequest['items'][$key]['change_size'] = 1;
                }
            }
        }
        return [$saveRequest];

    }
}